﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;

public partial class MovingViewState : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack) LoadFiles();
    }

    private void LoadFiles()
    {
        //Generate a lot of viewstate:
        GridView1.DataSource = from f in (new DirectoryInfo(@"C:\")).GetFiles() select f;
        GridView1.DataBind();
    }

    protected override void Render(HtmlTextWriter writer)
    {

        StringWriter stringWriter = new StringWriter();
        HtmlTextWriter htmlWriter = new HtmlTextWriter(stringWriter);

        base.Render(htmlWriter);
        
        string html = stringWriter.ToString();
        
        int StartPoint = html.IndexOf("<input type=\"hidden\" name=\"__VIEWSTATE\"");
        
        if (StartPoint >= 0)
        {
            int EndPoint = html.IndexOf("/>", StartPoint) + 2;
            string viewstateInput = html.Substring(StartPoint, EndPoint - StartPoint);
            
            html = html.Remove(StartPoint, EndPoint - StartPoint);
            
            int FormEndStart = html.IndexOf("</form>") ;
        
            if (FormEndStart >= 0)
            {
                html = html.Insert(FormEndStart, viewstateInput);
            }
        }
        writer.Write(html);
    }
}