﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Text;
using System.Diagnostics;

/// <summary>
/// Summary description for EncryptQueryString
/// </summary>
public class EncryptQueryString
{
    
    //Function to encode the string 
    public static string Encrypt(string value) 
    { 
        return Convert.ToBase64String(Encoding.UTF8.GetBytes(value)); 
    } 
    
    //Function to decode the string 
    static string Decrypt(string value) 
    { 
        string dataValue = ""; 
        
        try 
        { 
            dataValue = Encoding.UTF8.GetString(Convert.FromBase64String(value.Split('-')[0])); 
        } 
        catch (Exception) 
        {
            Debugger.Break();
        } 
            
        return dataValue; 
    }

    /// <summary> 
    /// Ontsleutelt de querystring van een url en geeft een dictonary terug met key-value paren 
    /// </summary> 
    /// <param name="Url">De gehele url zoals in HttpContext.Current.Request.Url.AbsoluteUri</param> 
    /// <returns></returns> 
    /// <remarks></remarks> 
    public static Dictionary<string, string> DecryptQueryString(string Url)
    {

        Dictionary<string, string> ReturnList = new Dictionary<string, string>();

        int iFirst = Url.IndexOf("?");
        if (iFirst < 1) return ReturnList;

        string EncryptedQueryString = Url.Substring(iFirst + 1);
        if (string.IsNullOrEmpty(EncryptedQueryString)) return ReturnList;

        string UnencryptedQueryString = "";
        try
        {
            UnencryptedQueryString = Decrypt(EncryptedQueryString);
        }
        catch (Exception )
        {
            return ReturnList;
        }

        string[] KeyValuesArray = UnencryptedQueryString.Split('&');

        foreach (string KeyValuePaar in KeyValuesArray)
        {
            string[] KeyValueArray = KeyValuePaar.Split('=');
            if (KeyValueArray.GetUpperBound(0) != 1) throw new Exception("Ongeldige querystring");
            ReturnList.Add(KeyValueArray[0], KeyValueArray[1]);
        }

        return ReturnList;
    } 
} 

