﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class Cookies_Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Request.Browser.Cookies)
            Response.Write("Uw browser ondersteunt geen cookies. U kunt deze site niet goed gebruiken!");
        else if (Request.QueryString["AcceptsCookies"] != null)
            Response.Write("Verander uw instellingen. Accepteer cookies!");
        else
            Response.Write("Uw browser ondersteunt cookies. U kunt gerust verder!");
    }
    protected void cmdRedirect_Click(object sender, EventArgs e)
    {
        //Eenvoudig cookie:
        HttpCookie cookUserName = new HttpCookie("Username");
        cookUserName.Value = txtName.Text;
        Response.Cookies.Add(cookUserName);

        //Multivalued cookies:
        Response.Cookies["UserInfo"]["UserName"] = txtName.Text;
        Response.Cookies["UserInfo"]["Language"] = "nl";


        //Permanent cookie:
        HttpCookie permCookie = new HttpCookie("PermCookie");
        permCookie.Value = txtName.Text;
        permCookie.Expires = DateTime.Now.AddDays(10);
        permCookie.Path = "/State";
        permCookie.Domain = "www.bogus.eu";


        Response.Cookies.Add(permCookie);



        //Navigate to next page:
        Response.Redirect("~/Cookies/LeesCookie.aspx");

    }
}
