﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class CountryPicker : System.Web.UI.UserControl
{
    public delegate void delChoiceComplete(object sender, CountryPickerEventArgs e);
    public delegate void delChoiceInvalid(bool CountryMissing, bool StateMissing);

    public event delChoiceComplete ChoiceComplete;
    public event delChoiceInvalid ChoiceInvalid;

    public class CountryPickerEventArgs : EventArgs
    {
        public string Country { get; set; }
        public string State { get; set; }
    }

    #region Properties

    public string Header
    {
        get
        {
            return lblHeader.Text;
        }
        set
        {
            lblHeader.Text = value;
        }
    }

    public string Choice
    {
        get
        {
            return lblChoice.Text;
        }
        private set
        {
            lblHeader.Text = value;
        }
    }

    public string Country
    {
        get
        {
            return ddlCountries.SelectedItem.Text;
        }
        private set
        {
            ddlCountries.Text = value;
        }
    }

    public string State
    {
        get
        {
            return ddlStates.SelectedItem.Text;
        }
        private set
        {
            ddlStates.Text = value;
        }
    }

    #endregion

    #region FillDropdowns

    protected void Page_Load(object sender, EventArgs e)
    {
        if (ViewState["IsPostBack"] == null)
        {
            ddlCountries.Items.Add(new ListItem("---Kies uw land ---", "0"));
            ddlCountries.Items.Add(new ListItem("Nederland", "1"));
            ddlCountries.Items.Add(new ListItem("België", "2"));
            ddlCountries.Items.Add(new ListItem("Duitsland", "3"));
            ddlStates.Items.Add(new ListItem("--- Kies uw provincie ---", "0"));

            ViewState["IsPostBack"] = true;
        }   
    }

    protected void ddlCountries_SelectedIndexChanged(object sender, EventArgs e)
    {
        ddlStates.Items.Clear();
        ddlStates.Items.Add(new ListItem("--- Kies uw provincie ---", "0"));

        switch (ddlCountries.SelectedValue)
        {
            case "1":
                ddlStates.Items.Add(new ListItem("Groningen", "1"));
                ddlStates.Items.Add(new ListItem("Friesland", "2"));
                ddlStates.Items.Add(new ListItem("Drenthe", "3"));
                ddlStates.Items.Add(new ListItem("Overijssel", "4"));
                ddlStates.Items.Add(new ListItem("Gelderland", "5"));
                ddlStates.Items.Add(new ListItem("Flevoland", "6"));
                ddlStates.Items.Add(new ListItem("Zuid-Holland", "7"));
                ddlStates.Items.Add(new ListItem("Noord-Holland", "8"));
                ddlStates.Items.Add(new ListItem("Utrecht", "9"));
                ddlStates.Items.Add(new ListItem("Zeeland", "10"));
                ddlStates.Items.Add(new ListItem("Noord-Brabant", "11"));
                ddlStates.Items.Add(new ListItem("Limburg", "12"));
                break;

            case "2":
                ddlStates.Items.Add(new ListItem("Antwerpen", "1"));
                ddlStates.Items.Add(new ListItem("West-Vlaanderen", "2"));
                ddlStates.Items.Add(new ListItem("Oost-Vlaanderen", "3"));
                ddlStates.Items.Add(new ListItem("Limburg", "4"));
                ddlStates.Items.Add(new ListItem("Vlaams-Brabant", "5"));
                ddlStates.Items.Add(new ListItem("Luik", "6"));
                ddlStates.Items.Add(new ListItem("Luxemburg", "7"));
                ddlStates.Items.Add(new ListItem("Namen", "8"));
                ddlStates.Items.Add(new ListItem("Waals-Brabant", "9"));
                ddlStates.Items.Add(new ListItem("Henegouwen", "10"));
                break;

            case "3":
                ddlStates.Items.Add(new ListItem("Baden-Württemberg", "1"));
                ddlStates.Items.Add(new ListItem("Bayern", "2"));
                ddlStates.Items.Add(new ListItem("Berlin", "3"));
                ddlStates.Items.Add(new ListItem("Brandenburg", "4"));
                ddlStates.Items.Add(new ListItem("Bremen", "5"));
                ddlStates.Items.Add(new ListItem("Hamburg", "6"));
                ddlStates.Items.Add(new ListItem("Hessen", "7"));
                ddlStates.Items.Add(new ListItem("Mecklenburg-Vorpommern", "8"));
                ddlStates.Items.Add(new ListItem("Niedersachsen", "9"));
                ddlStates.Items.Add(new ListItem("Nordrhein-Westfalen", "10"));
                ddlStates.Items.Add(new ListItem("Rheinland-Pfalz", "11"));
                ddlStates.Items.Add(new ListItem("Saarland", "12"));
                ddlStates.Items.Add(new ListItem("Sachsen", "13"));
                ddlStates.Items.Add(new ListItem("Sachsen-Anhalt", "14"));
                ddlStates.Items.Add(new ListItem("Schleswig-Holstein", "15"));
                ddlStates.Items.Add(new ListItem("Thüringen", "16"));
                break;
            default:
                break;
        }
    }

    #endregion

    protected void ddlStates_SelectedIndexChanged(object sender, EventArgs e)
    {
        lblChoice.Text = string.Format("Land = {0}; Provincie = {1}", Country, State);

        if (ddlCountries.SelectedIndex != -1 && ddlStates.SelectedIndex != -1)
        {//Raise event to hosting page:
            CountryPickerEventArgs cpeArgs = new CountryPickerEventArgs();
            cpeArgs.Country = ddlCountries.SelectedItem.Text;
            cpeArgs.State = ddlStates.SelectedItem.Text;

            ChoiceComplete(this, cpeArgs);
        }
        else
        {
            ChoiceInvalid(ddlCountries.SelectedIndex == -1, ddlStates.SelectedIndex == -1);
        }
    }


}
