﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class DynamicUsercontrol : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (IsPostBack)
        {
            if (ViewState["ControlCount"] != null)
            {
                int iNumber = Convert.ToInt32(ViewState["ControlCount"]);
                LoadControls(iNumber);
            }
        }
    }
    protected void ddlNumber_SelectedIndexChanged(object sender, EventArgs e)
    {
        int iNumber = Convert.ToInt32(ddlNumber.SelectedItem.Text);

        LoadControls(iNumber);
        ViewState["ControlCount"] = iNumber;
    }

    private void LoadControls(int ControlCount)
    {
        phControls.Controls.Clear();

        for (int i = 0; i < ControlCount; i++)
        {
            Control ctr = LoadControl("~/CountryPicker.ascx");
            CountryPicker cp = (CountryPicker)ctr;
            cp.ID = "CountryPicker" + i.ToString();
            cp.ChoiceComplete += new CountryPicker.delChoiceComplete(cp_ChoiceComplete);
            cp.Header = "Country Picker nummer " + (i + 1).ToString();
            phControls.Controls.Add(cp);
            phControls.Controls.Add(new LiteralControl("<br/>"));
            Label lblResult = new Label();
            lblResult.ID = "lblResult" + i.ToString();
            phControls.Controls.Add(lblResult);
            phControls.Controls.Add(new LiteralControl("<hr/>"));

        }
    }

    void cp_ChoiceComplete(object sender, CountryPicker.CountryPickerEventArgs e)
    {
        CountryPicker cPick = sender as CountryPicker;
        string sID = cPick.ID;
        string sLabelID = sID.Replace("CountryPicker", "");
        Label lblMessage = phControls.FindControl("lblResult" + sLabelID) as Label;
        lblMessage.Text = string.Format("ControlID = {0}, Land = {1}; Provincie = {2}", cPick.ID, e.Country, e.State);

    }

}
