﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

using System.Data.SqlClient;
//using System.Data.SqlTypes;
using System.Data;
using System.Configuration;

public class CData
{
    public static SqlConnection GetConnection()
    {
        //Put this connection string in the web.config file, or use a variable with this value:
        //string conString = @"Data Source=.\SQLEXPRESS;AttachDbFilename=|DataDirectory|\northwnd.mdf;Integrated Security=True;User Instance=True;";

        string conString =
            ConfigurationManager.ConnectionStrings["connNWind"].ConnectionString;

        SqlConnection con = new SqlConnection(conString);
        return con;
    }

    public static SqlDataReader GetEmployees()
    {
        string sql = "SELECT EmployeeID, FirstName + ' ' + LastName AS FullName FROM Employees";

        SqlCommand com = new SqlCommand(sql);
        com.Connection = GetConnection();
        com.Connection.Open();

        SqlDataReader dr = com.ExecuteReader(CommandBehavior.CloseConnection);

        //Scroll through all records:
        //while (dr.Read())
        //{
        //    int i = dr.GetInt32(0);
        //    string s = dr.GetString(1);

        //    //Or:
        //    if (dr.IsDBNull(1))
        //        s = "";
        //    else
        //        s = dr.GetString(1);
        //}

        //Close Connection safely:
        //if(com.Connection.State == ConnectionState.Open)
        //    com.Connection.Close();

        return dr;
    }

    //Second example, as learning tool:
    public static void GetEmployees2()
    {
        string sql = "SELECT EmployeeID, FirstName + ' ' + LastName AS FullName FROM Employees";

        using (SqlConnection cn = GetConnection())
        {
            SqlCommand com = new SqlCommand(sql);

            cn.Open();

            SqlDataReader dr = com.ExecuteReader();

            //Do somthing with the data..
        }
    }

    public static DataTable GetOrdersForEmployee(int EmpID)
    {
        string sql =string.Format("SELECT * FROM Orders WHERE EmployeeID={0}", EmpID);
        SqlDataAdapter da = new SqlDataAdapter(sql, GetConnection());
        
        DataTable dt = new DataTable();
        da.Fill(dt);

        return dt;
    }

    //Idem, now using parameters:
    public static DataTable GetOrdersForEmployeePM(int EmpID)
    {
        string sql = "SELECT * FROM Orders WHERE EmployeeID=@pmEmpID";
        SqlDataAdapter da = new SqlDataAdapter(sql, GetConnection());
        da.SelectCommand.Parameters.AddWithValue("@pmEmpID", EmpID);
        DataTable dt = new DataTable();
        da.Fill(dt);

        return dt;
    }

    //Idem, now using a stored procedure:
    public static DataTable GetOrdersForEmployeeSP(int EmpID)
    {
        //spEmpOrders text: "SELECT * FROM Orders WHERE EmployeeID=@EmpID"
        SqlCommand com = new SqlCommand("spEmpOrders", GetConnection());
        com.CommandType = CommandType.StoredProcedure;
        com.Parameters.AddWithValue("@EmpID", EmpID);

        SqlDataAdapter da = new SqlDataAdapter();
        da.SelectCommand = com;

        DataTable dt = new DataTable("EmpOrders");
        da.Fill(dt);

        return dt;

        //Or:
        //SqlParameter param1 = new SqlParameter("@EmpID", SqlDbType.Int);

    }



    public static SqlDataReader FindEmployee(int employeeID)
    {
        SqlCommand com = new SqlCommand(
            "SELECT EmployeeID, FirstName, LastName FROM Employees WHERE EmployeeID=" + employeeID);
        //com.CommandType = CommandType.Text;
        com.Connection = GetConnection();
        com.Connection.Open();
        SqlDataReader dr = com.ExecuteReader(CommandBehavior.CloseConnection);

        return dr;

    }

    // Voor pagina AddEmp.aspx:

    public static int InsertEmployee(string FirstName, string LastName)
    {
        string sSql =
            string.Format("INSERT INTO Employees(Firstname,Lastname) VALUES('{0}','{1}')", FirstName, LastName);
        SqlCommand com = new SqlCommand(sSql);

        com.Connection = GetConnection();
        com.Connection.Open();
        int iResult = com.ExecuteNonQuery();
        com.Connection.Close();

        return iResult;
    }

    public static int DeleteEmployee(int EmployeeID)
    {
        string sSql =
            string.Format("DELETE Employees WHERE EmployeeID={0}", EmployeeID);
        SqlCommand com = new SqlCommand(sSql);

        com.Connection = GetConnection();

        com.Connection.Open();
        int iResult = com.ExecuteNonQuery();
        com.Connection.Close();

        return iResult;
    }

    public static int UpdateEmployee(int EmployeeID, string FirstName, string LastName)
    {
        string sSql =
            string.Format("UPDATE Employees SET Firstname='{0}',LastName='{1}' WHERE EmployeeID={2}", FirstName, LastName, EmployeeID);
        SqlCommand com = new SqlCommand(sSql);

        com.Connection = GetConnection();
        com.Connection.Open();

        int iResult = com.ExecuteNonQuery();
        com.Connection.Close();

        return iResult;
    }

}

