﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

using System.Data.SqlClient;
using System.Data;
using System.Diagnostics;

public class DataAdapterDemo
{

    public static void RunDataAdapterDemo()
    {
        Debugger.Break();

        //Prepare DataAdapter and Connection objects:
        SqlDataAdapter da = new SqlDataAdapter();
        SqlConnection cn = CData.GetConnection();

        //Prepare all four Commands:
        string sqlSel = "SELECT FirstName, LastName FROM Employees";
        SqlCommand comSel = new SqlCommand(sqlSel, cn);
        da.SelectCommand = comSel;

        string sqlIns = "INSERT INTO Employees(Firstname, Lastname) VALUES(@FirstName, @LastName)";
        SqlCommand comIns = new SqlCommand(sqlIns, cn);
        da.InsertCommand = comIns;
        da.InsertCommand.Parameters.Add(new SqlParameter("@FirstName", SqlDbType.NVarChar, 10, "FirstName"));
        da.InsertCommand.Parameters.Add(new SqlParameter("@LastName", SqlDbType.NVarChar, 20, "LastName"));

        string sqlUpd = "UPDATE Employees SET LastName=@LastName WHERE FirstName=@FirstName";
        SqlCommand comUpd = new SqlCommand(sqlUpd, cn);
        da.UpdateCommand = comUpd;
        da.UpdateCommand.Parameters.Add(new SqlParameter("@FirstName", SqlDbType.NVarChar, 10, "FirstName"));
        da.UpdateCommand.Parameters.Add(new SqlParameter("@LastName", SqlDbType.NVarChar, 20, "LastName"));

        string sqlDel = "DELETE Employees WHERE Firstname=@FirstName";
        SqlCommand comDel = new SqlCommand(sqlDel, cn);
        da.DeleteCommand = comDel;
        da.DeleteCommand.Parameters.Add(new SqlParameter("@FirstName", SqlDbType.NVarChar, 10, "FirstName"));


        //Fill Datatable:
        DataTable dt = new DataTable();
        da.Fill(dt);

        HttpContext.Current.Session["DT"] = dt;
        HttpContext.Current.Session["DA"] = da;

        TestChanges();
    }

    private static void TestChanges()
    {//Normally, this function will be called from a webform action.

        Debugger.Break();

        DataTable dt = (DataTable)HttpContext.Current.Session["DT"];
        SqlDataAdapter da = (SqlDataAdapter)HttpContext.Current.Session["DA"];

        //Do insert:
        dt.Rows.Add(new object[2] { "Donald", "Duck" });
        da.Update(dt);

        //Do update:
        dt.Rows[dt.Rows.Count - 1]["LastName"] = "DUCK";
        da.Update(dt);

        //Do delete:
        dt.Rows[dt.Rows.Count - 1].Delete();
        da.Update(dt);

    }
}
