using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

using System.Data.SqlClient;

public class CBlob
{
    /// <summary>
    /// Deze methode haalt n foto op.
    /// </summary>
    /// <param name="EmpID">ID nummer van de foto</param>
    /// <returns></returns>
    public static byte[] GetPicture(int EmpID)
    {
        Byte[] photoData = null;

        using (SqlConnection cn = CData.GetConnection())
        {
            SqlCommand com = new SqlCommand("SELECT Photo2 FROM Employees WHERE EmployeeID = @EmpID", cn);

            com.Parameters.AddWithValue("@EmpID", EmpID);

            com.Connection.Open();

            SqlDataReader dr = com.ExecuteReader();

            if (dr.HasRows)
            {
                dr.Read();
                if (!dr.IsDBNull(0))
                {
                    photoData = new Byte[Convert.ToInt32((dr.GetBytes(0, 0, null, 0, Int32.MaxValue)))];
                    long bytesReceived = dr.GetBytes(0, 0, photoData, 0, photoData.Length);
                }
            }
        }
        return photoData;
    }

    /// <summary>
    /// Deze methode bewaart foto's in de database door een byte array op te slaan als BLOB veld in de database.
    /// </summary>
    /// <param name="EmpID"></param>
    /// <param name="PhotoData"></param>
    /// <returns></returns>
    public static bool SavePicture(int EmpID, byte[] PhotoData)
    {
        int rowsUpdated = 0;

        using (SqlConnection cn = CData.GetConnection())
        {
            string sql = "UPDATE Employees SET Photo2 = @Photo WHERE EmployeeID = @EmpID";
            SqlCommand com = new SqlCommand(sql, cn);
            
            com.Connection.Open();

            com.Parameters.AddWithValue("@EmpID", EmpID);
            
            SqlParameter param = new SqlParameter("@Photo", SqlDbType.VarBinary, PhotoData.Length);
            param.Value = PhotoData;
            com.Parameters.Add(param);

            rowsUpdated = (int)com.ExecuteNonQuery();

        }
        return (rowsUpdated > 0);
    }

}
