﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

public class ProductClass
{
    static NorthwindDataDataContext dc = new NorthwindDataDataContext();

    public static object SelectAll()
    {
        var query = from p in dc.Products
                    where p.ProductID <= 10
                    select new { p.ProductID, p.ProductName, p.UnitPrice, p.Discontinued };

        return query;
    }

    public static Product Select(int ID)
    {
        var query = from p in dc.Products
                    where p.ProductID == ID
                    select p;

        return query.First<Product>();
    }

    public static void Insert(Product prod)
    {
        dc.Products.InsertOnSubmit(prod);
        dc.SubmitChanges();
    }

    public static void Update(Product prod)
    {
        var product = (from p in dc.Products
                       where p.ProductID == prod.ProductID
                       select p).Single();

        product.ProductName = prod.ProductName;
        product.UnitPrice = prod.UnitPrice;
        product.Discontinued = prod.Discontinued;

        dc.SubmitChanges();
    }

    public static void Delete(Product prod)
    {
        var delProduct = (from p in dc.Products
                          where p.ProductID == prod.ProductID
                          select p).Single();
        dc.Products.DeleteOnSubmit(delProduct);
        dc.SubmitChanges();
    }


}
