﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Xml;
using System.Xml.Xsl;
using System.Xml.Schema;
using System.Xml.XPath;
using System.IO;
using System.Data;
using System.Data.SqlClient;


public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            if (File.Exists(@"XML\Temp.xml")) File.Delete(@"XML\Temp.xml");
            if (File.Exists(@"XML\Visitors1.xml")) File.Delete(@"XML\Visitors1.xml");
        }
    }

    protected void lbXMLReader_Click(object sender, EventArgs e)
    {
        XmlTextReader reader = new XmlTextReader(@"XML\Visitors.xml");
        string sNode = "";

        while (reader.Read())
        {
            if (reader.NodeType == XmlNodeType.Element ||
                reader.NodeType == XmlNodeType.Text)
            {
                sNode = "";
                for (int i = 1; i <= reader.Depth; i++)
                {
                    sNode += "";
                }
                sNode += (reader.Name + " " + reader.NodeType.ToString());

                if (reader.HasValue)
                    sNode += (": " + reader.Value);

                phXML.Controls.Add(new LiteralControl(sNode + "<br />"));

                if (reader.HasAttributes)
                {
                    while (reader.MoveToNextAttribute())
                    {
                        sNode = "";
                        for (int i = 1; i <= reader.Depth; i++)
                        {
                            sNode += " ";
                        }
                        sNode += (reader.Name + " " + reader.NodeType.ToString());

                        if (reader.HasValue)
                            sNode += (": " + reader.Value);

                        phXML.Controls.Add(new LiteralControl(sNode + "<br />"));

                    }
                }
            }
        }
        reader.Close();
    }

    protected void lbXmlDocument_Click(object sender, EventArgs e)
    {

        XmlTextReader reader = new XmlTextReader(@"XML\Visitors.xml");
        reader.WhitespaceHandling = WhitespaceHandling.None;
        XmlDocument doc = new XmlDocument();
        doc.Load(reader);
        reader.Close();

        XmlNode root = doc.DocumentElement;
        XmlNode nodX;

        if (root.HasChildNodes)
        {
            nodX = root.FirstChild;

            while (!(nodX == null))
            {
                phXML.Controls.Add(new LiteralControl(nodX.InnerXml + "<br />"));
                nodX = nodX.NextSibling;
            }
        }


    }

    protected void lbCreateDoc_Click(object sender, EventArgs e)
    {
        //Create the XmlDocument:
        XmlDocument doc = new XmlDocument();
        string xmlData = "<Visitor xmlns:vis='urn:demos'></Visitor>";

        doc.Load(new StringReader(xmlData));

        //Create a new element; add it to the XmlDocument:
        XmlElement elem = doc.CreateElement("vis", "VisitorType", "urn:demos");
        elem.InnerText = "Gold Member";
        doc.DocumentElement.AppendChild(elem);

        doc.Save(@"XML\Temp.xml");

        //Create System.Web.UI.WebControls.XML control:
        Xml xmlControl = new Xml();
        xmlControl.DocumentSource = Server.MapPath("~/XML/Temp.xml");
        phXML.Controls.Add(xmlControl);

    }

    protected void lbXmlDataDocument_Click(object sender, EventArgs e)
    {
        string sAllText = File.OpenText(@"XML\Visitors.xml").ReadToEnd();
        phXML.Controls.Add(new LiteralControl(sAllText + "<br />"));

        XmlDataDocument doc = new XmlDataDocument();

        doc.DataSet.ReadXmlSchema(@"XML\Visitors.xml");
        doc.Load(@"XML\Visitors.xml");

        DataSet ds = doc.DataSet;

        ds.Tables[0].Rows[0][4] = 100;
        ds.AcceptChanges();
        doc.Save(@"XML\Visitors1.xml");

        sAllText = File.OpenText(@"XML\Visitors1.xml").ReadToEnd();

        phXML.Controls.Add(new LiteralControl(sAllText + "<br />"));

        return;     //Statements below are incomplete and will fire Exception

        //Start with DataSet:
        DataSet dsVisitors = new DataSet();
        SqlDataAdapter da = new SqlDataAdapter();
        //TODO: Init DataAdapter ...
        da.Fill(dsVisitors, "Visitors");
        XmlDataDocument docVis = new XmlDataDocument(dsVisitors);
    }

    protected void lbXPath_Click(object sender, EventArgs e)
    {

        //PREPARE:
        string sXPath = "";
        XmlNodeList list;

        FileStream fs = new FileStream(@"XML\Visitors.xml", FileMode.Open);
        XmlTextReader xmlRead = new XmlTextReader(fs);

        xmlRead.WhitespaceHandling = WhitespaceHandling.None;
        XmlDocument xmlDoc = new XmlDocument();
        xmlDoc.Load(xmlRead);

        //THE DEMOS:

        //1. Get all Visitor entries:
        sXPath = "Visitors/Visitor";
        list = xmlDoc.SelectNodes(sXPath);
        WriteInfo(list);
        phXML.Controls.Add(new LiteralControl("<hr />"));

        //2. Get them without specifying the "Visitors" parent node:
        sXPath = "*/Visitor";
        list = xmlDoc.SelectNodes(sXPath);
        WriteInfo(list);
        phXML.Controls.Add(new LiteralControl("<hr />"));

        //3. Just get the E-mail addresses:
        sXPath = "Visitors/*/Email";
        list = xmlDoc.SelectNodes(sXPath);
        WriteInfo(list);
        phXML.Controls.Add(new LiteralControl("<hr />"));

        //4. Get all "SSN" attributes:
        sXPath = "Visitors/Visitor/@SSN";
        list = xmlDoc.SelectNodes(sXPath);
        WriteInfo(list);
        phXML.Controls.Add(new LiteralControl("<hr />"));

        //5. Or use simply the attribute name:
        sXPath = "//@SSN";
        list = xmlDoc.SelectNodes(sXPath);
        WriteInfo(list);
        phXML.Controls.Add(new LiteralControl("<hr />"));

        //6. Get all attributes:
        sXPath = "//@*";
        list = xmlDoc.SelectNodes(sXPath);
        WriteInfo(list);
        phXML.Controls.Add(new LiteralControl("<hr />"));

        //7. Get all visitors from the TestCompany company:
        sXPath = "//Company[.='TestCompany']";
        list = xmlDoc.SelectNodes(sXPath);
        WriteInfo(list);
        phXML.Controls.Add(new LiteralControl("<hr />"));

        //7b. Get all visitors from the TestCompany company, but return the e-mail address, not the Company:
        sXPath = "//Visitor[Company='TestCompany']/Email";
        list = xmlDoc.SelectNodes(sXPath);
        WriteInfo(list);
        phXML.Controls.Add(new LiteralControl("<hr />"));

        //8. Get Visitor with SSN Attribute 12810:
        sXPath = "//Visitor[@SSN='12810']";
        list = xmlDoc.SelectNodes(sXPath);
        WriteInfo(list);
        phXML.Controls.Add(new LiteralControl("<hr />"));

        //8b. Get Visitor with SSN Attribute 12810, but return e-mail:
        sXPath = "//Visitor[@SSN='12810']/Email";
        list = xmlDoc.SelectNodes(sXPath);
        WriteInfo(list);
        phXML.Controls.Add(new LiteralControl("<hr />"));

        fs.Close();
    }

    protected void lbXPathNavigator_Click(object sender, EventArgs e)
    {
        XPathDocument doc = new XPathDocument(@"XML\Visitors.xml");
        XPathNavigator nav = doc.CreateNavigator();

        XPathNodeIterator it = nav.Select("/Visitors/Visitor/FirstName");

        //Use next line to get all descendants;
        //If xmlns attribute is set on "Visitors", this line helps to still see the children.
        //it = nav.SelectDescendants(XPathNodeType.Text,false);

        while (it.MoveNext())
        {
            Console.Write(it.Current.NodeType.ToString() + ": ");
            Console.Write(it.Current.Name + " = ");
            Console.WriteLine(it.Current.Value);

            phXML.Controls.Add(new LiteralControl(it.Current.NodeType.ToString() + ": " + "<br/>"));
            phXML.Controls.Add(new LiteralControl(it.Current.Name + " = "));
            phXML.Controls.Add(new LiteralControl(it.Current.Value + "<br/>"));

        }
    }

    protected void lbXSDSchema_Click(object sender, EventArgs e)
    {
        Server.Transfer("~/XSDValidator.aspx");
    }

    protected void lbXSLDemo_Click(object sender, EventArgs e)
    {
        Server.Transfer("~/XSLDemo.aspx");        
    }


    protected void lbLinqToXml_Click(object sender, EventArgs e)
    {
        Server.Transfer("~/LinqToXml.aspx");
    }

    #region Utility
    
    void WriteInfo(XmlNodeList list)
    {
        foreach (XmlNode item in list)
        {


            if (item.HasChildNodes)
            {
                XmlNodeList innerList = item.ChildNodes;

                //Call recursively into this function to enumerate all the child nodes:
                WriteInfo(innerList);
            }
            else
            {
                phXML.Controls.Add(new LiteralControl(item.Value + "<br />"));
            }

            //Write attributes:
            if (!(item.Attributes == null) && (item.Attributes.Count > 0))
            {
                for (int k = 0; k < item.Attributes.Count; k++)
                {
                    phXML.Controls.Add(new LiteralControl(item.Attributes[k].Name + " = "));
                    phXML.Controls.Add(new LiteralControl(item.Attributes[k].InnerText + "<br />"));
                }
            }
        }
    }

    #endregion
    
}
