﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Linq;
using System.Xml.Linq;
using System.IO;

public partial class LinqToXml : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    protected void lbCreate_Click(object sender, EventArgs e)
    {
        XDocument docXml = new XDocument(
              new XDeclaration("1.0", "utf-8", "yes"),
              new XComment("Operators for the Application"),
              new XElement("operators",
                  new XElement("operator",
                      new XElement("name", "Charlotte"),
                      new XAttribute("age", "28"),
                      new XElement("email", "charlotte@abc.eu")
                  ),
                  new XElement("operator",
                      new XElement("name", "Hopkirk"),
                      new XAttribute("age", "41"),
                      new XElement("email", "patrick@abc.eu")
                  )
              )
          );

        docXml.Save(@"XML\Operators.xml");
    }
    protected void lbSearch_Click(object sender, EventArgs e)
    {
        Literal1.Text = "";

        if(!File.Exists(@"XML\Operators.xml"))
        {
            Literal1.Text = "Bestand 'Operators.xml' kan niet worden gevonden!";
            return;
        }

        Literal1.Text += "*** SIMPLE DUMP" + "<br/>";

        XDocument Operators = XDocument.Load(@"XML\Operators.xml");
        var elements = Operators.Root.Elements();

        foreach (XElement elt in elements)
            Literal1.Text += elt.ToString() + "<br/>";

        Literal1.Text += "*** JUST NAMES MATCHING A QUERY";
        var names = from c in Operators.Root.Elements("operator")
                    where (int)c.Attribute("age") == 28
                    orderby (string)c.Element("email")
                    select new
                    {
                        name = (string)c.Element("name"),
                        email = (string)c.Element("email")
                    };

        foreach (var elt in names)
            Literal1.Text += elt.ToString() + "<br/>";
    }
}
