﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Xml;
using System.Xml.Schema;

public partial class XSDValidator : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    public void ValidateXML(string xmlFile, string valFile, ValidationType valType)
    {
        if (valType != ValidationType.DTD && valType != ValidationType.Schema)
        {
            lblMessage.Text = "Invalid validation type! Use schema or DTD!";
        }

        //Create settings:
        XmlReaderSettings settings = new XmlReaderSettings();
        settings.ProhibitDtd = false;   //Required if using DTD
        settings.ValidationEventHandler += new ValidationEventHandler(ValidationError);
        settings.ValidationType = valType;
        
        //Open xml file:
        XmlReader reader = XmlReader.Create(xmlFile, settings);

        XmlDocument doc = new XmlDocument();
        doc.Load(reader);
        phResults.Controls.Add(new LiteralControl("Validation Complete"));
    }

    private void ValidationError(object sender, ValidationEventArgs e)
    {
        phResults.Controls.Add(new LiteralControl(e.Message + "<br />"));
        phResults.Controls.Add(new LiteralControl("Validation Complete"));
    }
    protected void lbValidateNow_Click(object sender, EventArgs e)
    {
        lblMessage.Text = "";

        string xmlFile = @"XML\Visitors.xml";
        string valFile = @"XML\Visitors.xsd";


        ValidationType valType = ValidationType.None;
        if (rblOption.SelectedIndex == 0)
            valType = ValidationType.Schema;
        else
            valType = ValidationType.DTD;

        try
        {
            ValidateXML(xmlFile, valFile, valType);
        }
        catch (Exception ex)
        {
            lblMessage.Text = "Error: " + ex.Message;
        }
    }
}
