﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Data;

public class CachedItems
{

    public static DataTable GetCachedDataTable(string TableName)
    {
        DataTable dtReturn = null;

        if (HttpContext.Current.Cache[TableName] != null)
        {   //If item is in cache, retrieve it:
            dtReturn = (DataTable)HttpContext.Current.Cache[TableName];
        }
        else
        {   //If not, request the object from data class (in the correct 'case'):
            switch (TableName)
            {
                case "Products":
                    //If not, request the object from data class:
                    dtReturn = Product.SelectAll();                    
                    break;

                case "Employees":
                    
                    dtReturn = Employee.SelectAll();
                    break;

                default:
                    break;
            }

            //And insert into the cache now:
            HttpContext.Current.Cache.Insert(TableName, dtReturn);
        }
        //Return DataTable to caller:
        return dtReturn;
    }

    public static void RemoveItemFromCache(string TableName)
    {
        HttpContext.Current.Cache.Remove("Products");
    }
}
