﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml.Linq;
using System.Web.Caching;

public partial class FileDependency : System.Web.UI.Page
{
    const string VISITORS = "Visitors";

    protected void lbLoadData_Click(object sender, EventArgs e)
    {
        Literal1.Text = "";

        XDocument Visitors = TryLoadFromCache();

        Literal1.Text += "*** JUST NAMES MATCHING A QUERY";
        var names = from c in Visitors.Root.Elements("Visitor")
                    where (int)c.Attribute("ID") >= 2
                    orderby (string)c.Element("Email")
                    select new
                    {
                        name = (string)c.Element("FirstName") + " " + (string)c.Element("LastName"),
                        email = (string)c.Element("Email")
                    };

        foreach (var elt in names)
            Literal1.Text += elt.ToString() + "<br/>";
    }

    private XDocument TryLoadFromCache()
    {
        if (Cache[VISITORS] == null)
        {
            XDocument Visitors = XDocument.Load(@"App_Data\Visitors.xml");

            TimeSpan tsSlid = TimeSpan.FromHours(12);
            del = new CacheItemRemovedCallback(this.ItemExpired);
            CacheDependency dep = new CacheDependency(Server.MapPath(@"~\App_Data\Visitors.xml"));

            Cache.Insert("Visitors", Visitors, dep, Cache.NoAbsoluteExpiration, tsSlid,CacheItemPriority.Normal, del);
            
            Cache[VISITORS] = Visitors;
            return Visitors;
        }
        else
        {
            return (XDocument)Cache[VISITORS];
        }
    }
    public void ItemExpired(string key, object value, CacheItemRemovedReason reason)
    {
        //Do work; e.g., insert into Cache again.
    }

    private static CacheItemRemovedCallback del = null;


}
