﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Caching;
using System.Data.SqlClient;
using System.Data;
using System.Configuration;
using System.Diagnostics;

public partial class SqlDependency : System.Web.UI.Page
{
    protected void lbFillGridView_Click(object sender, EventArgs e)
    {
        SqlCacheDependency SqlDep = null;
        DataTable dt = null;

        if (Cache["SqlSource"] == null)
        {
            try
            {
                SqlDep = new SqlCacheDependency("Northwind", "Products");
            }
            catch (DatabaseNotEnabledForNotificationException exDBDis)
            {
                Debug.WriteLine(exDBDis.Message);
                try
                {
                    SqlCacheDependencyAdmin.EnableNotifications(
                        ConfigurationManager.ConnectionStrings["connNWind"].ConnectionString);
                }
                catch (UnauthorizedAccessException exPerm)
                {
                    Debug.WriteLine(exPerm.Message);
                }
            }
            catch (TableNotEnabledForNotificationException exTabDis)
            {
                Debug.WriteLine(exTabDis.Message);
                try
                {
                    SqlCacheDependencyAdmin.EnableTableForNotifications(
                        ConfigurationManager.ConnectionStrings["connNWind"].ConnectionString, "Products");
                }
                catch (SqlException exc)
                {
                    Debug.WriteLine(exc.Message);
                }
            }
            finally
            {
                dt = Product.SelectAll();
                Cache.Insert("SqlSource", dt, SqlDep);
                lblMessage.Text = "The data object was created explicitly.";
            }
        }
        else
        {
            dt = (DataTable)Cache["SqlSource"];
            lblMessage.Text = "The data was retrieved from the Cache.";
        }

        gvProducts.DataSource = dt;
        gvProducts.DataBind();
    }
}
