﻿using System;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.WebControls;
using System.Web.UI;

namespace CountryWeather
{
    /// <summary>
    /// CONNECTION PROVIDER
    /// </summary>
    public class CountryList : WebPart, ICountryWeather
    {

        private DropDownList cboCountries;
        private string sCountry;

        protected override void CreateChildControls()
        {
            cboCountries = new DropDownList();

            cboCountries.Items.Add("--- Pick a country! ---");
            cboCountries.Items.Add("Greece");
            cboCountries.Items.Add("Turkey");
            cboCountries.Items.Add("Spain");
            cboCountries.Items.Add("Portugal");
            cboCountries.AutoPostBack = true;

            cboCountries.SelectedIndexChanged += cboCountries_SelectedIndexChanged;

            Controls.Add(cboCountries);

            Controls.Add(new LiteralControl("Select a country from the list to view the weather conditions<br/><hr/><br/>"));
        }

        protected void cboCountries_SelectedIndexChanged(object sender, EventArgs e)
        {
            CountryID = cboCountries.SelectedValue;
        }

        [ConnectionProvider("CountryID", "CountryID")]
        public ICountryWeather ProvideMemberInfo()
        {
            return this;
        }

        public string CountryID
        {
            get { return sCountry; }
            set { sCountry = value; }
        }
    }
}