﻿using System;
using System.Web.UI;

using System.Web.Security;
using System.Web.Profile;

public partial class PersonalizationDemo : System.Web.UI.Page
{
    protected void Page_PreInit(object sender, EventArgs e)
    {
        string culture = Profile.Language;

        Page.Culture = culture;
        Page.UICulture = culture;

        lblFirstName.Text = GetLocalResourceObject("lblFirstNameResource1.Text").ToString();
        lblLastName.Text = GetLocalResourceObject("lblLastNameResource1.Text").ToString();
        lblDOB.Text = GetLocalResourceObject("lblDOBResource1.Text").ToString();

    }

    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            txtFirstName.Text = Profile.Personal.FirstName;
            txtLastName.Text = Profile.Personal.LastName;
            txtDOB.Text = Profile.Personal.DateOfBirth.ToShortDateString();
        }

        string sLocalizedGreeting = GetLocalResourceObject("CustomGreeting").ToString();
        lblGreeting.Text = string.Format(sLocalizedGreeting, Profile.Personal.FirstName);
    }
    protected void cmdApply_Click(object sender, EventArgs e)
    {
        Profile.Personal.FirstName = txtFirstName.Text;
        Profile.Personal.LastName = txtLastName.Text;
        Profile.Personal.DateOfBirth = Convert.ToDateTime(txtDOB.Text);

        Server.Transfer("~/Default.aspx");
    }

     void Profile_MigrateAnonymous(object sender, ProfileMigrateEventArgs e)
    {
        ProfileCommon anonProfile =
          Profile.GetProfile(e.AnonymousID);

        Profile.Personal.FirstName = anonProfile.Personal.FirstName;
        Profile.Personal.LastName = anonProfile.Personal.LastName;
        Profile.Personal.DateOfBirth = anonProfile.Personal.DateOfBirth;

        AnonymousIdentificationModule.ClearAnonymousIdentifier();
    }
 
}
