﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Threading;

public class ImageAsynchOperation : IAsyncResult
{
    private bool _completed;
    private object _state;
    private AsyncCallback _callback;
    private HttpContext _context;

    public ImageAsynchOperation(AsyncCallback callback, HttpContext context, object state)
    {
        _callback = callback;
        _context = context;
        _state = state;
        _completed = false;
    }

    public object AsyncState
    {
        get { return _state; }
    }

    public System.Threading.WaitHandle AsyncWaitHandle
    {
        get { return null; }
    }

    public bool CompletedSynchronously
    {
        get { return false; }
    }

    public bool IsCompleted
    {
        get { return _completed; }
    }

    public void StartAsync()
    {
        ThreadPool.QueueUserWorkItem(new WaitCallback(StartAsyncOperation), null);
    }

    public void StartAsyncOperation(object workItemState)
    {
        HttpRequest Request = _context.Request;
        HttpResponse Response = _context.Response;

        if (Request.RawUrl.ToLower().Contains("jellyfish"))
        {
            Response.Write("<p>JellyFish</p>");
        }
        else if (Request.RawUrl.ToLower().Contains("koala"))
        {
            Response.Write("<p>Koala</p>");
        }
        else
        {
            Response.Write("<p>Not found</p>");
        }

        Thread.Sleep(3000);

        Response.Write("<p>Async operation completed</p>");

        _completed = true;
        _callback(this);
    }
}
