﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

using System.Data;
using System.Data.SqlClient;
using System.Configuration;

public class Products : IProducts
{
    public Product GetProductByID(int id)
    {
        string sql = "SELECT ProductID, ProductName, UnitPrice, Discontinued FROM Products WHERE ProductID=@pmProductID";
        Product prod = null;
        using (SqlConnection cn = GetConnection())
        {
            SqlCommand com = new SqlCommand(sql, cn);
            com.Parameters.AddWithValue("@pmProductID", id);
            cn.Open();
            SqlDataReader reader = com.ExecuteReader();

            if (reader.Read())
            {
                prod = new Product();

                prod.ProductID = reader.GetInt32(0);
                prod.ProductName = reader.GetString(1);
                prod.UnitPrice = (reader.IsDBNull(2) ? 0.0M : reader.GetDecimal(2));
                prod.Discontinued = reader.GetBoolean(3);
            }
            return prod;
        }
    }

    public DataTable GetAllProducts()
    {
        string sql = "SELECT TOP (10) ProductID, ProductName, UnitPrice, Discontinued FROM Products";
        DataTable dt = new DataTable("Products");
        using (SqlConnection cn = GetConnection())
        {
            SqlDataAdapter da = new SqlDataAdapter(sql, cn);
            da.Fill(dt);

            return dt;
        }
    }

    SqlConnection GetConnection()
    {
        string conString =
            ConfigurationManager.ConnectionStrings["connNWind"].ConnectionString;

        SqlConnection con = new SqlConnection(conString);
        return con;
    }
}
