using System;
using System.Data;
using System.Configuration;
using System.Data.SqlClient;
using System.Diagnostics;
using System.Net.Mail;
using System.Net.Mime;
using System.IO;

public class Email
{
    private const string MYHOST = "smtp.fastbird.eu";
    private const string TO = "fromwebsite@fastbird.eu";
    private const string FROM = "fromwebsite@fastbird.eu";


    public static bool SendMail(string sSubject, string sBody)
    {
        return SendMail(sSubject, sBody, "");
    }

    public static bool SendMail(string sSubject, string sBody, string sAttachment)
    {
        MailMessage msg = new MailMessage();
        msg.From = new MailAddress(FROM);
        msg.To.Add(new MailAddress(TO));
        
        msg.IsBodyHtml = true;
        msg.Subject = sSubject;
        msg.Body = sBody;

        if (sAttachment.Trim() != "" && File.Exists(sAttachment))
        {
            FileStream fs = new FileStream(sAttachment, FileMode.Open, FileAccess.Read);
            msg.Attachments.Add(new Attachment(sAttachment, MediaTypeNames.Application.Octet));
            fs.Close();
        }

        try
        {
            SmtpClient client = new SmtpClient(MYHOST);
            client.Send(msg);
        }
        catch (InvalidOperationException ex)
        {
            Debug.Print(ex.Message);
            return false;

        }
        catch (SmtpException ex)
        {
            Debug.Print(ex.Message);
            return false;

        }
        catch (Exception ex)
        {
            Debug.Print(ex.Message);
            return false;
        }
        return true;
    }
}
